//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UforPrac4.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TforPrac3 *forPrac3;
//---------------------------------------------------------------------------
__fastcall TforPrac3::TforPrac3(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TforPrac3::Aadir1Click(TObject *Sender)
{
        vuelo = new TforNuevoVuelo(NULL);
        vuelo->setCompany(company);
        vuelo->ShowModal();
        delete vuelo;
}
//---------------------------------------------------------------------------

void __fastcall TforPrac3::FormCreate(TObject *Sender)
{
        company = new tCompany();
        archivo = "";
        OpenDialog1->Filter = "Ficheros binarios (*.bin)|*.BIN";
        SaveDialog1->Filter = "Ficheros binarios (*.bin)|*.BIN";
        //OpenDialog1->DefaultExt = ("bin", "bin");  // No necesario
        SaveDialog1->DefaultExt = ("bin", "bin");
}
//---------------------------------------------------------------------------

void __fastcall TforPrac3::FormDestroy(TObject *Sender)
{
        delete company;
}
//---------------------------------------------------------------------------

void __fastcall TforPrac3::Aadir2Click(TObject *Sender)
{
        reserv = new TforReservas(NULL);
        reserv->setCompany(company);
        reserv->ShowModal();
        delete reserv;
}
//---------------------------------------------------------------------------

void __fastcall TforPrac3::GuardarComo1Click(TObject *Sender)
{
        if(SaveDialog1->Execute())
        {
                archivo = SaveDialog1->FileName;
                Guardar1->Enabled = true;
                TforPrac3::Guardar1Click(NULL);
        }
}
//---------------------------------------------------------------------------

void __fastcall TforPrac3::Guardar1Click(TObject *Sender)
{
        if(archivo != "")
        {
                company->salvar(archivo.c_str());
        }
}
//---------------------------------------------------------------------------

void __fastcall TforPrac3::Cargar1Click(TObject *Sender)
{
        if(OpenDialog1->Execute())
        {
                archivo = OpenDialog1->FileName;
                Guardar1->Enabled = true;
                company->cargar(archivo.c_str());
        }
}
//---------------------------------------------------------------------------

void __fastcall TforPrac3::Eliminar1Click(TObject *Sender)
{
        AnsiString valor;
        int i;
        if(company->dameNumVuelos() > 0)
        {
                if(InputQuery("Eliminar vuelo", "Escriba el vuelo a eliminar", valor))
                {
                        i = valor.ToInt();
                        valor = "";
                        if(company->eliminaVuelo(i))
                        {
                                ShowMessage("Vuelo eliminado");
                        }
                        else
                        {
                                ShowMessage("Error. Ha escrito bien el identificador de vuelo?");
                        }
                }
        }
        else
        {
                ShowMessage("Error. No hay vuelos en la base de datos");
        }
}
//---------------------------------------------------------------------------

void __fastcall TforPrac3::Eliminar2Click(TObject *Sender)
{
        AnsiString valor;
        int i, j;
        if(company->dameNumVuelos() > 0)
        {
                if(InputQuery("Eliminar reserva...", "Escriba la reserva a eliminar", valor))
                {
                        i = valor.ToInt();
                        valor = "";
                        if(InputQuery("Eliminar reserva...", "Escriba a que vuelo pertenece", valor))
                        {
                                j = valor.ToInt();
                                tLocalizador loc(j, i, reservado);
                                if(company->eliminaReserva(loc))
                                {
                                        ShowMessage("Reserva numero " + IntToStr(i) + " eliminada del vuelo " + IntToStr(j) + ".");
                                }
                                else
                                {
                                        ShowMessage("Error. Ha escrito bien el identificador de vuelo o el de la reserva?");
                                }
                        }
                }
        }
        else
        {
                ShowMessage("Error. No hay vuelos en la base de datos");
        }
}
//---------------------------------------------------------------------------

void __fastcall TforPrac3::CheckIn1Click(TObject *Sender)
{
        checkin = new TforCheckIn(NULL);
        checkin->setCia(company);
        checkin->ShowModal();
        delete checkin;
}
//---------------------------------------------------------------------------

