//---------------------------------------------------------------------------

#ifndef UforReservasH
#define UforReservasH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Grids.hpp>
#include "UtCompany.h"
//---------------------------------------------------------------------------
class TforReservas : public TForm
{
__published:	// IDE-managed Components
        TLabel *Label1;
        TLabel *Label2;
        TEdit *ediOri;
        TEdit *ediDes;
        TButton *botBuscar;
        TButton *botOk;
        TButton *botCancel;
        TStringGrid *grid;
        void __fastcall botOkClick(TObject *Sender);
        void __fastcall botCancelClick(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall botBuscarClick(TObject *Sender);
        void __fastcall gridSelectCell(TObject *Sender, int ACol, int ARow,
          bool &CanSelect);
private:	// User declarations
        tCompany* cia;
        int vuel;
        void limpiaGrid();
public:		// User declarations
        __fastcall TforReservas(TComponent* Owner);
        void setCompany(tCompany* cia) {this->cia = cia;};
        tCompany* getCompany() {return cia;};
};
//---------------------------------------------------------------------------
extern PACKAGE TforReservas *forReservas;
//---------------------------------------------------------------------------
#endif
